#property copyright "Copyright  2005, klot"
#property link      "klot@mail.ru"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue

extern int depth = 5;
extern int GrossPeriod = 240;
double gda_84[];
double gda_88[];
int gia_92[];

int init() {
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexArrow(0, 159);
   SetIndexBuffer(0, gda_84);
   SetIndexEmptyValue(0, 0.0);
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexArrow(1, 159);
   SetIndexBuffer(1, gda_88);
   SetIndexEmptyValue(1, 0.0);
   if (Period() > GrossPeriod) {
      Alert("DT-ZigZag", GrossPeriod);
      return (0);
   }
   ArrayCopySeries(gia_92, 5, Symbol(), GrossPeriod);
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int li_8;
   double ld_12;
   int li_0 = IndicatorCounted();
   int li_4 = 300;
   if (li_0 < 0) return (-1);
   if (li_0 > 0) li_0--;
   li_4 = Bars - li_0;
   for (int li_20 = 0; li_20 < li_4; li_20++) {
      if (Time[li_20] >= gia_92[0]) li_8 = 0;
      else {
         li_8 = ArrayBsearch(gia_92, Time[li_20 - 1], WHOLE_ARRAY, 0, MODE_DESCEND);
         if (Period() <= GrossPeriod) li_8++;
      }
      for (int li_24 = li_8; li_24 < li_8 + 100; li_24++) {
         ld_12 = iCustom(NULL, GrossPeriod, "ZigZag", depth, 5, 3, 0, li_24 + 1);
         if (ld_12 != 0.0) break;
      }
      if (iClose(NULL, 0, li_20 + 1) <= ld_12) gda_88[li_20] = ld_12;
      else gda_88[li_20] = 0.0;
      if (iClose(NULL, 0, li_20 + 1) >= ld_12) gda_84[li_20] = ld_12;
      else gda_84[li_20] = 0.0;
      ObjectsRedraw();
   }
   return (0);
}